From e231a162939e09cb159d4338f6ac1f8a23cd7ae0 Mon Sep 17 00:00:00 2001
From: Gwenael Casaccio <mrgwen@gmail.com>
Date: Thu, 5 Dec 2013 10:26:13 +0100
Subject: [PATCH] Migrate to new UI framework first step done:   - introduce
 new UI;   - remove most of the mainWidget calls;   - more rationale in widget
 initialization;   - less Gtk dependant.

---
 packages/visualgst/ChangeLog                       |  75 ++++
 .../Commands/WorkspaceMenus/DeleteItemCommand.st   |   2 +-
 .../Commands/WorkspaceMenus/InspectItemCommand.st  |   2 +-
 packages/visualgst/Debugger/Extensions.st          |   3 +-
 packages/visualgst/Debugger/GtkContextWidget.st    |  38 +-
 packages/visualgst/Debugger/GtkDebugger.st         |   8 +-
 packages/visualgst/Debugger/GtkStackInspector.st   |   2 +-
 .../visualgst/Debugger/GtkStackInspectorView.st    |   3 +-
 packages/visualgst/Extensions.st                   |   6 +
 packages/visualgst/Gtk/GtkListModel.st             | 133 +++++++
 packages/visualgst/Gtk/GtkScrollTreeWidget.st      |  83 ++++
 packages/visualgst/Gtk/GtkTreeModel.st             | 176 +++++++++
 packages/visualgst/GtkClassSUnitWidget.st          |  99 -----
 packages/visualgst/GtkConcreteWidget.st            |  15 +-
 packages/visualgst/GtkEntryDialog.st               |  10 +-
 packages/visualgst/GtkEntryWidget.st               |   2 +-
 packages/visualgst/GtkHSidebarWidget.st            |  42 --
 packages/visualgst/GtkHistoryWidget.st             |  59 +--
 packages/visualgst/GtkLauncher.st                  |  85 ++--
 packages/visualgst/GtkListModel.st                 | 133 -------
 packages/visualgst/GtkMainWindow.st                | 311 ---------------
 packages/visualgst/GtkMethodSUnitWidget.st         |  51 ---
 packages/visualgst/GtkNotebookWidget.st            | 187 ---------
 packages/visualgst/GtkScrollTreeWidget.st          |  83 ----
 packages/visualgst/GtkSidebarWidget.st             | 130 ------
 packages/visualgst/GtkTranscriptWidget.st          |   2 +-
 packages/visualgst/GtkTreeModel.st                 | 176 ---------
 packages/visualgst/GtkVSidebarWidget.st            |  42 --
 packages/visualgst/GtkVariableTrackerWidget.st     |  29 +-
 packages/visualgst/GtkVisualGSTTool.st             |   2 +-
 packages/visualgst/GtkWorkspaceWidget.st           |  13 +-
 packages/visualgst/Image/GtkImageWidget.st         |  53 ++-
 .../Implementors/GtkImageResultsWidget.st          |  23 +-
 .../Implementors/GtkImplementorResultsWidget.st    |  11 +-
 .../Implementors/GtkSenderResultsWidget.st         |  11 +-
 .../Inspector/GtkCharacterInspectorView.st         |  62 ---
 .../Inspector/GtkCompiledBlockInspectorView.st     | 124 ------
 .../Inspector/GtkCompiledMethodInspectorView.st    | 133 -------
 .../visualgst/Inspector/GtkContextInspectorView.st |  58 ---
 .../Inspector/GtkDictionaryInspectorView.st        |  53 ---
 .../visualgst/Inspector/GtkFloatInspectorView.st   |  51 ---
 packages/visualgst/Inspector/GtkInspector.st       |  29 +-
 .../Inspector/GtkInspectorBrowserWidget.st         |  39 +-
 packages/visualgst/Inspector/GtkInspectorWidget.st |  38 +-
 .../visualgst/Inspector/GtkIntegerInspectorView.st |  62 ---
 .../visualgst/Inspector/GtkObjectInspectorView.st  |  88 -----
 .../GtkSequenceableCollectionInspectorView.st      |  51 ---
 .../visualgst/Inspector/GtkSetInspectorView.st     |  53 ---
 .../Inspector/View/GtkCharacterInspectorView.st    |  62 +++
 .../View/GtkCompiledBlockInspectorView.st          | 124 ++++++
 .../View/GtkCompiledMethodInspectorView.st         | 133 +++++++
 .../Inspector/View/GtkContextInspectorView.st      |  58 +++
 .../Inspector/View/GtkDictionaryInspectorView.st   |  53 +++
 .../Inspector/View/GtkFloatInspectorView.st        |  51 +++
 .../Inspector/View/GtkIntegerInspectorView.st      |  62 +++
 .../Inspector/View/GtkObjectInspectorView.st       |  88 +++++
 .../View/GtkSequenceableCollectionInspectorView.st |  51 +++
 .../Inspector/View/GtkSetInspectorView.st          |  53 +++
 packages/visualgst/Menus/HistorySelectionMenus.st  |  43 ++
 packages/visualgst/SUnit/GtkClassSUnitWidget.st    | 106 +++++
 packages/visualgst/SUnit/GtkMethodSUnitWidget.st   |  51 +++
 packages/visualgst/SUnit/GtkSUnit.st               |  60 +--
 packages/visualgst/SUnit/GtkSUnitResultWidget.st   |  52 +--
 .../StBrowser/GtkCategorizedClassWidget.st         |  69 ++--
 .../StBrowser/GtkCategorizedNamespaceWidget.st     |  51 ++-
 packages/visualgst/StBrowser/GtkCategoryWidget.st  |  64 ++-
 .../visualgst/StBrowser/GtkClassBrowserWidget.st   |  68 ++--
 .../visualgst/StBrowser/GtkClassHierarchyWidget.st |  42 +-
 packages/visualgst/StBrowser/GtkMethodWidget.st    |  42 +-
 packages/visualgst/Tetris/Tetris.st                |   2 +-
 packages/visualgst/Text/GtkFindWidget.st           | 125 ------
 packages/visualgst/Text/GtkReplaceWidget.st        | 103 -----
 packages/visualgst/Text/GtkSaveTextWidget.st       |  89 -----
 packages/visualgst/Text/GtkSourceCodeWidget.st     | 287 --------------
 packages/visualgst/Text/GtkTextPluginWidget.st     |  90 -----
 packages/visualgst/Text/GtkTextWidget.st           | 435 ---------------------
 packages/visualgst/Widget/Box.st                   |  82 ++++
 packages/visualgst/Widget/Compoment.st             |  65 +++
 packages/visualgst/Widget/Entry.st                 |  67 ++++
 packages/visualgst/Widget/HBox.st                  |  44 +++
 packages/visualgst/Widget/HPaned.st                |  44 +++
 packages/visualgst/Widget/HSidebar.st              |  43 ++
 packages/visualgst/Widget/Label.st                 |  59 +++
 packages/visualgst/Widget/List.st                  | 178 +++++++++
 packages/visualgst/Widget/Notebook.st              | 187 +++++++++
 packages/visualgst/Widget/Paned.st                 | 122 ++++++
 packages/visualgst/Widget/Sidebar.st               | 123 ++++++
 packages/visualgst/Widget/Text/GtkFindWidget.st    | 125 ++++++
 packages/visualgst/Widget/Text/GtkReplaceWidget.st | 103 +++++
 .../visualgst/Widget/Text/GtkSaveTextWidget.st     |  89 +++++
 .../visualgst/Widget/Text/GtkSourceCodeWidget.st   | 289 ++++++++++++++
 .../visualgst/Widget/Text/GtkTextPluginWidget.st   |  90 +++++
 packages/visualgst/Widget/Text/GtkTextWidget.st    | 433 ++++++++++++++++++++
 packages/visualgst/Widget/Tree.st                  | 168 ++++++++
 packages/visualgst/Widget/VBox.st                  |  44 +++
 packages/visualgst/Widget/VPaned.st                |  44 +++
 packages/visualgst/Widget/VSidebar.st              |  43 ++
 packages/visualgst/Widget/Widget.st                | 181 +++++++++
 packages/visualgst/Widget/Window.st                | 314 +++++++++++++++
 packages/visualgst/package.xml                     |  98 ++---
 100 files changed, 4762 insertions(+), 3728 deletions(-)
 create mode 100644 packages/visualgst/Gtk/GtkListModel.st
 create mode 100644 packages/visualgst/Gtk/GtkScrollTreeWidget.st
 create mode 100644 packages/visualgst/Gtk/GtkTreeModel.st
 delete mode 100644 packages/visualgst/GtkClassSUnitWidget.st
 delete mode 100644 packages/visualgst/GtkHSidebarWidget.st
 delete mode 100644 packages/visualgst/GtkListModel.st
 delete mode 100644 packages/visualgst/GtkMainWindow.st
 delete mode 100644 packages/visualgst/GtkMethodSUnitWidget.st
 delete mode 100644 packages/visualgst/GtkNotebookWidget.st
 delete mode 100644 packages/visualgst/GtkScrollTreeWidget.st
 delete mode 100644 packages/visualgst/GtkSidebarWidget.st
 delete mode 100644 packages/visualgst/GtkTreeModel.st
 delete mode 100644 packages/visualgst/GtkVSidebarWidget.st
 delete mode 100644 packages/visualgst/Inspector/GtkCharacterInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkCompiledBlockInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkCompiledMethodInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkContextInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkDictionaryInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkFloatInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkIntegerInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkObjectInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkSequenceableCollectionInspectorView.st
 delete mode 100644 packages/visualgst/Inspector/GtkSetInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkCharacterInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkCompiledBlockInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkCompiledMethodInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkContextInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkDictionaryInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkFloatInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkIntegerInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkObjectInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkSequenceableCollectionInspectorView.st
 create mode 100644 packages/visualgst/Inspector/View/GtkSetInspectorView.st
 create mode 100644 packages/visualgst/Menus/HistorySelectionMenus.st
 create mode 100644 packages/visualgst/SUnit/GtkClassSUnitWidget.st
 create mode 100644 packages/visualgst/SUnit/GtkMethodSUnitWidget.st
 delete mode 100644 packages/visualgst/Text/GtkFindWidget.st
 delete mode 100644 packages/visualgst/Text/GtkReplaceWidget.st
 delete mode 100644 packages/visualgst/Text/GtkSaveTextWidget.st
 delete mode 100644 packages/visualgst/Text/GtkSourceCodeWidget.st
 delete mode 100644 packages/visualgst/Text/GtkTextPluginWidget.st
 delete mode 100644 packages/visualgst/Text/GtkTextWidget.st
 create mode 100644 packages/visualgst/Widget/Box.st
 create mode 100644 packages/visualgst/Widget/Compoment.st
 create mode 100644 packages/visualgst/Widget/Entry.st
 create mode 100644 packages/visualgst/Widget/HBox.st
 create mode 100644 packages/visualgst/Widget/HPaned.st
 create mode 100644 packages/visualgst/Widget/HSidebar.st
 create mode 100644 packages/visualgst/Widget/Label.st
 create mode 100644 packages/visualgst/Widget/List.st
 create mode 100644 packages/visualgst/Widget/Notebook.st
 create mode 100644 packages/visualgst/Widget/Paned.st
 create mode 100644 packages/visualgst/Widget/Sidebar.st
 create mode 100644 packages/visualgst/Widget/Text/GtkFindWidget.st
 create mode 100644 packages/visualgst/Widget/Text/GtkReplaceWidget.st
 create mode 100644 packages/visualgst/Widget/Text/GtkSaveTextWidget.st
 create mode 100644 packages/visualgst/Widget/Text/GtkSourceCodeWidget.st
 create mode 100644 packages/visualgst/Widget/Text/GtkTextPluginWidget.st
 create mode 100644 packages/visualgst/Widget/Text/GtkTextWidget.st
 create mode 100644 packages/visualgst/Widget/Tree.st
 create mode 100644 packages/visualgst/Widget/VBox.st
 create mode 100644 packages/visualgst/Widget/VPaned.st
 create mode 100644 packages/visualgst/Widget/VSidebar.st
 create mode 100644 packages/visualgst/Widget/Widget.st
 create mode 100644 packages/visualgst/Widget/Window.st

diff --git a/packages/visualgst/ChangeLog b/packages/visualgst/ChangeLog
index ed475dd..8bc960c 100644
--- a/packages/visualgst/ChangeLog
+++ b/packages/visualgst/ChangeLog
@@ -1,5 +1,80 @@
 2013-12-02  Gwenael Casaccio  <gwenael.casaccio@gmail.com>
 
+	* Commands/WorkspaceMenus/DeleteItemCommand.st: New UI support.
+	* Commands/WorkspaceMenus/InspectItemCommand.st: New UI support.
+	* Debugger/Extensions.st: Disable the debugger.
+	* Debugger/GtkContextWidget.st: Migration to new UI.
+	* Debugger/GtkDebugger.st: Migration to new UI.
+	* Debugger/GtkStackInspector.st: Migration to new UI.
+	* Debugger/GtkStackInspectorView.st: Migration to new UI.
+	* Extensions.st: Migration to new UI.
+	* Gtk/GtkListModel.st: Move to Gtk.
+	* Gtk/GtkScrollTreeWidget.st: Move to Gtk.
+	* Gtk/GtkTreeModel.st: Move to Gtk.
+	* GtkConcreteWidget.st: Update to new UI.
+	* GtkEntryDialog.st: Update to new UI.
+	* GtkEntryWidget.st: Update to new UI.
+	* GtkHistoryWidget.st: Update to new UI.
+	* GtkLauncher.st: Update to new UI.
+	* GtkTranscriptWidget.st: Update to new UI.
+	* GtkVariableTrackerWidget.st: Update to new UI.
+	* GtkVisualGSTTool.st: Update to new UI.
+	* GtkWorkspaceWidget.st: Update to new UI.
+	* Image/GtkImageWidget.st: Update to new UI.
+	* Implementors/GtkImageResultsWidget.st: Update to new UI.
+	* Implementors/GtkImplementorResultsWidget.st: Update to new UI.
+	* Implementors/GtkSenderResultsWidget.st: Update to new UI.
+	* Inspector/GtkInspector.st: Update to new UI.
+	* Inspector/GtkInspectorBrowserWidget.st: Update to new UI.
+	* Inspector/GtkInspectorWidget.st: Update to new UI.
+	* Inspector/View/GtkCharacterInspectorView.st: Move inspector view.
+	* Inspector/View/GtkCompiledBlockInspectorView.st: Move inspector view.
+	* Inspector/View/GtkCompiledMethodInspectorView.st: Move inspector view.
+	* Inspector/View/GtkContextInspectorView.st: Move inspector view.
+	* Inspector/View/GtkDictionaryInspectorView.st: Move inspector view.
+	* Inspector/View/GtkFloatInspectorView.st: Move inspector view.
+	* Inspector/View/GtkIntegerInspectorView.st: Move inspector view.
+	* Inspector/View/GtkObjectInspectorView.st: Move inspector view.
+	* Inspector/View/GtkSequenceableCollectionInspectorView.st: Move inspector view.
+	* Inspector/View/GtkSetInspectorView.st: Move inspector view.
+	* Menus/HistorySelectionMenus.st: New history popup menu.
+	* SUnit/GtkClassSUnitWidget.st: Update to new UI.
+	* SUnit/GtkMethodSUnitWidget.st: Update to new UI.
+	* SUnit/GtkSUnit.st: Update to new UI.
+	* SUnit/GtkSUnitResultWidget.st: Update to new UI.
+	* StBrowser/GtkCategorizedClassWidget.st: Update to new UI.
+	* StBrowser/GtkCategorizedNamespaceWidget.st: Update to new UI.
+	* StBrowser/GtkCategoryWidget.st: Update to new UI.
+	* StBrowser/GtkClassBrowserWidget.st: Update to new UI.
+	* StBrowser/GtkClassHierarchyWidget.st: Update to new UI.
+	* StBrowser/GtkMethodWidget.st: Update to new UI.
+	* Tetris/Tetris.st: Update to new UI.
+	* Widget/Box.st: Box widget.
+	* Widget/Compoment.st: Compoment.
+	* Widget/Entry.st: Entry widget.
+	* Widget/HBox.st: Horizontal box widget.
+	* Widget/HPaned.st: Horizontal paned widget.
+	* Widget/HSidebar.st: Horizontal sidebar widget.
+	* Widget/Label.st: Label widget.
+	* Widget/List.st: List widget.
+	* Widget/Notebook.st: Notebook widget.
+	* Widget/Paned.st: Paned widget.
+	* Widget/Sidebar.st: Sidebar widget.
+	* Widget/Text/GtkFindWidget.st: Find text widget.
+	* Widget/Text/GtkReplaceWidget.st: Replace text widget.
+	* Widget/Text/GtkSaveTextWidget.st: Save source warning widget.
+	* Widget/Text/GtkSourceCodeWidget.st: Smalltalk source widget.
+	* Widget/Text/GtkTextPluginWidget.st: Text widget plugin.
+	* Widget/Text/GtkTextWidget.st: Text widget
+	* Widget/Tree.st: Tree widget.
+	* Widget/VBox.st: Vertical box widget.
+	* Widget/VPaned.st: Vertical paned widget.
+	* Widget/VSidebar.st: Vertical sidebar widget.
+	* Widget/Widget.st: Widget.
+	* Widget/Window.st: Window widget.
+
+2013-12-02  Gwenael Casaccio  <gwenael.casaccio@gmail.com>
+
        * GtkConcreteWidget.st: Object is the superclass.
        * GtkAbstractConcreteWidget.st: Remove it.
        * GtkSidebarWidget.st: Doesn't rely on GtkAbstractConcreteWidget.
diff --git a/packages/visualgst/Commands/WorkspaceMenus/DeleteItemCommand.st b/packages/visualgst/Commands/WorkspaceMenus/DeleteItemCommand.st
index c0433ad..2a0a63c 100644
--- a/packages/visualgst/Commands/WorkspaceMenus/DeleteItemCommand.st
+++ b/packages/visualgst/Commands/WorkspaceMenus/DeleteItemCommand.st
@@ -43,7 +43,7 @@ Command subclass: DeleteItemCommand [
     valid [
 	<category: 'command'>
 
-        ^ target hasSelectedItem
+        ^ target hasSelection
     ]
 
     execute [
diff --git a/packages/visualgst/Commands/WorkspaceMenus/InspectItemCommand.st b/packages/visualgst/Commands/WorkspaceMenus/InspectItemCommand.st
index 2d9cf5d..2b7dd88 100644
--- a/packages/visualgst/Commands/WorkspaceMenus/InspectItemCommand.st
+++ b/packages/visualgst/Commands/WorkspaceMenus/InspectItemCommand.st
@@ -43,7 +43,7 @@ InspectItCommand subclass: InspectItemCommand [
     valid [
 	<category: 'command'>
 
-        ^ target hasSelectedValue
+        ^ target hasSelection
     ]
 ]
 
diff --git a/packages/visualgst/Debugger/Extensions.st b/packages/visualgst/Debugger/Extensions.st
index 5d011b6..3895161 100644
--- a/packages/visualgst/Debugger/Extensions.st
+++ b/packages/visualgst/Debugger/Extensions.st
@@ -38,7 +38,8 @@ Behavior extend [
     debuggerClass [
         <category: '*VisualGST-debugger'>
 
-        ^ VisualGST.GtkDebugger
+        ^ nil
+"        ^ VisualGST.GtkDebugger"
     ]
 ]
 
diff --git a/packages/visualgst/Debugger/GtkContextWidget.st b/packages/visualgst/Debugger/GtkContextWidget.st
index 902f6c5..50fa75e 100644
--- a/packages/visualgst/Debugger/GtkContextWidget.st
+++ b/packages/visualgst/Debugger/GtkContextWidget.st
@@ -33,14 +33,14 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkContextWidget [
-    | column contextTree model context contextList |
+Compoment subclass: GtkContextWidget [
+
+    | context contextList |
 
     GtkContextWidget class >> on: aContext [
 	<category: 'instance creation'>
 
-	^ (self new)
-	    initialize;
+	^ self new
 	    context: aContext;
 	    yourself
     ]
@@ -48,14 +48,14 @@ GtkConcreteWidget subclass: GtkContextWidget [
     initialize [
 	<category: 'initialization'>
 
-	self mainWidget: self buildTreeView
+	self buildTreeView
     ]
 
     context: aContext [
 	<category: 'accessing'>
 
 	context := aContext.
-	model
+	widget
 	    item: self buildListOfContexts;
 	    refresh
     ]
@@ -74,20 +74,16 @@ GtkConcreteWidget subclass: GtkContextWidget [
 
     buildTreeView [
         <category: 'user interface'>
-    
-        contextTree := GtkScrollTreeWidget createListWithModel: {{GtkColumnTextType title: 'Contexts'}}.
-        contextTree connectToWhenPopupMenu: (ContextMenus on: self).
-        contextTree treeView getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-        (model := GtkListModel on: contextTree treeView getModel)
-                                        contentsBlock: [ :each | {each printString} ].
-        ^ contextTree mainWidget
+
+        self widget: (List column: {{GtkColumnTextType title: 'Contexts'}} contents: [ :each | {each printString} ]).
+        widget popupMenu: (ContextMenus on: self).
+        widget singleSelection.
     ]
 
     whenSelectionChangedSend: aSelector to: anObject [
 	<category: 'events'>
 
-	contextTree treeView getSelection
-	    connectSignal: 'changed' to: anObject selector: aSelector userData: nil
+	widget whenSelectionChangedSend: aSelector to: anObject
     ]
 
     isLastContextSelected [
@@ -99,19 +95,19 @@ GtkConcreteWidget subclass: GtkContextWidget [
     selectLastContext [
         <category: 'item selection'>
 
-	contextTree treeView selectLastItem
+	widget selectLastItem
     ]
 
     selectFirstContext [
         <category: 'item selection'>
 
-	contextTree treeView selectFirstItem
+	widget selectFirstItem
     ]
 
     hasSelectedContext [
 	<category: 'testing'>
 
-	^ contextTree treeView hasSelectedItem
+	^ widget hasSelection
     ]
 
     selectedContext [
@@ -119,15 +115,15 @@ GtkConcreteWidget subclass: GtkContextWidget [
 
 
 	self hasSelectedContext ifFalse: [ self error: 'Nothing is selected' ].
-        ^ contextTree treeView selection
+        ^ widget selection
     ]
 
     state [
         <category: 'actions'>
 
         "TODO: add ContextState."
-        contextTree treeView hasSelectedItem ifTrue: [
-            ^MethodState with: contextTree treeView selection method method ].
+        widget treeView hasSelectedItem ifTrue: [
+            ^MethodState with: self selection method ].
         ^BrowserState new
     ]
 
diff --git a/packages/visualgst/Debugger/GtkDebugger.st b/packages/visualgst/Debugger/GtkDebugger.st
index 91a5073..031b7a3 100644
--- a/packages/visualgst/Debugger/GtkDebugger.st
+++ b/packages/visualgst/Debugger/GtkDebugger.st
@@ -117,25 +117,25 @@ GtkBrowsingTool subclass: GtkDebugger [
 	^ (stackInspectorWidget := GtkStackInspector new)
             parentWindow: window;
 	    initialize;
-	    mainWidget
+            yourself
     ]
 
     buildInspectorsWidget [
 	<category: 'user interface'>
 
-	^ GTK.GtkHPaned addAll: {self buildInspectorWidget mainWidget. self buildStackInspectorWidget}
+	^ HPaned addAll: {self buildInspectorWidget. self buildStackInspectorWidget}
     ]
 
     buildCodeAndStateWidget [
 	<category: 'intialize-release'>
 
-	^ GTK.GtkVPaned addAll: {self buildSourceWidget mainWidget. self buildInspectorsWidget}
+	^ VPaned addAll: {self buildSourceWidget. self buildInspectorsWidget}
     ]
 
     buildCentralWidget [
 	<category: 'intialize-release'>
 
-	^ GTK.GtkVPaned addAll: {self buildContextWidget mainWidget. self buildCodeAndStateWidget}
+	^ VPaned addAll: {self buildContextWidget. self buildCodeAndStateWidget}
     ]
 
     createExecuteMenus [
diff --git a/packages/visualgst/Debugger/GtkStackInspector.st b/packages/visualgst/Debugger/GtkStackInspector.st
index fa2f1c7..3bb1e87 100644
--- a/packages/visualgst/Debugger/GtkStackInspector.st
+++ b/packages/visualgst/Debugger/GtkStackInspector.st
@@ -40,7 +40,7 @@ GtkInspectorWidget subclass: GtkStackInspector [
 
         object := aContext.
         objectView := object stackInspectorView openOn: self object.
-        model
+        inspectorTree
             item: objectView;
             refresh
     ]
diff --git a/packages/visualgst/Debugger/GtkStackInspectorView.st b/packages/visualgst/Debugger/GtkStackInspectorView.st
index 19355ab..b8ea3ee 100644
--- a/packages/visualgst/Debugger/GtkStackInspectorView.st
+++ b/packages/visualgst/Debugger/GtkStackInspectorView.st
@@ -33,7 +33,8 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkStackInspectorView [
+Object subclass: GtkStackInspectorView [
+
     | object args temps |
 
     GtkStackInspectorView class >> openOn: aContext [
diff --git a/packages/visualgst/Extensions.st b/packages/visualgst/Extensions.st
index 0661d7d..9a36b20 100644
--- a/packages/visualgst/Extensions.st
+++ b/packages/visualgst/Extensions.st
@@ -518,6 +518,12 @@ GTK.GtkTreeView extend [
 	^ model
     ]
 
+    unselectAll [
+	<category: 'accessing'>
+
+        self getSelection unselectAll.
+    ]
+
     selection [
 	<category: 'accessing'>
 
diff --git a/packages/visualgst/Gtk/GtkListModel.st b/packages/visualgst/Gtk/GtkListModel.st
new file mode 100644
index 0000000..c39925c
--- /dev/null
+++ b/packages/visualgst/Gtk/GtkListModel.st
@@ -0,0 +1,133 @@
+"======================================================================
+|
+| GtkListModel class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Object subclass: GtkListModel [
+
+    GtkListModel class >> on: aGtkListStore [
+	<category: 'instance creation'>
+
+	^ super new
+	    initialize;
+	    gtkModel: aGtkListStore;
+	    yourself
+    ]
+
+    | contentsBlock item model |
+
+    initialize [
+	<category: 'initialization'>
+
+    ]
+
+    gtkModel: aGtkListStore [
+	<category: 'accessing'>
+
+	model := aGtkListStore
+    ]
+
+    item: anObject [
+	<category: 'accessing'>
+
+	item := anObject
+    ]
+
+    item [
+	<category: 'accessing'>
+
+	^ item
+    ]
+
+    contentsBlock: aBlock [
+	<category: 'accessing'>
+
+	contentsBlock := aBlock
+    ]
+
+    contentsBlock [
+	<category: 'accessing'>
+
+	^ contentsBlock
+    ]
+
+    append: anItem [
+	<category: 'model'>
+
+	model appendItem: ((self contentsBlock value: anItem) copyWith: anItem)
+    ]
+
+    remove: anObject [
+	<category: 'model'>
+
+	| iter |
+	(iter := self findIter: anObject) ifNil: [ self error: 'item not found' ].
+	model remove: iter
+    ]
+
+    clear [
+	<category: 'model'>
+
+	model clear
+    ]
+
+    refresh [
+	<category: 'model'>
+
+	self clear.
+	self item ifNil: [ ^ self ].
+	self item do: [ :each | self append: each ]
+    ]
+
+    hasItem: anObject [
+        <category: 'item selection'>
+
+        self findIter: anObject ifAbsent: [ ^ false ].
+        ^ true
+    ]
+
+    findIter: anObject ifAbsent: aBlock [
+	<category: 'item selection'>
+
+	model do: [ :elem :iter |
+	    elem last = anObject ifTrue: [ ^ iter ] ].
+	aBlock value
+    ]
+
+    findIter: anObject [
+	<category: 'item selection'>
+
+	^ self findIter: anObject ifAbsent: [ self error: 'Item not found' ]
+    ]
+]
+
diff --git a/packages/visualgst/Gtk/GtkScrollTreeWidget.st b/packages/visualgst/Gtk/GtkScrollTreeWidget.st
new file mode 100644
index 0000000..2bd9c4a
--- /dev/null
+++ b/packages/visualgst/Gtk/GtkScrollTreeWidget.st
@@ -0,0 +1,83 @@
+"======================================================================
+|
+| GtkScrollTreeWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkConcreteWidget subclass: GtkScrollTreeWidget [
+
+    GtkScrollTreeWidget class >> createListWithModel: anObject [
+	<category: 'instance creation'>
+
+	^ self basicNew
+		treeView: (GTK.GtkTreeView createListWithModel: anObject);
+		initialize;
+		yourself
+    ]
+
+    GtkScrollTreeWidget class >> createTreeWithModel: anObject [
+        <category: 'instance creation'>
+
+        ^ self basicNew
+                treeView: (GTK.GtkTreeView createTreeWithModel: anObject);
+                initialize;
+                yourself
+    ]
+
+    | treeView |
+
+    initialize [
+	<category:'initialize'>
+
+	popupMenu := [ :value | ].
+	self buildTreeView.
+	self mainWidget: (GTK.GtkScrolledWindow withChild: self treeView)
+    ]
+
+    buildTreeView [
+	<category: 'user interface'>
+
+    ]
+
+    treeView: aGtkTreeView [
+	<category: 'accessing'>
+
+	treeView := aGtkTreeView.
+    ]
+
+    treeView [
+	<category: 'accessing'>
+
+	^ treeView
+    ]
+]
+
